;##########################################################################
.386
.model flat, stdcall
option casemap:none
title Trillian MSN Static IP Patcher
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
include C:\masm32\include\comdlg32.inc
include C:\masm32\include\wsock32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
includelib C:\masm32\lib\comdlg32.lib
includelib C:\masm32\lib\wsock32.lib
;##########################################################################
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
;##########################################################################
;##########################################################################
	CurDate		TEXTEQU	<">, @Date, <">
	CurTime		TEXTEQU	<">, @Time, <">
	CurFileName	TEXTEQU	<">, @FileCur, <">

	msn_filepos	equ	00011ECEh
	msn_filesize	equ	344064
;##########################################################################
DlgProc		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
Patch		PROTO
FreeRes		PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szAppTitle	db		"Trillian MSN Static IP Patcher", 0
	szMsgAbout	db		"Trillian MSN Static IP Patcher", 13, 10
			db		"Built on ", CurDate, " ", CurTime, 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://www.comrade64.com/", 13, 10
			db		"http://comrade64.cjb.net/", 13, 10
			db		"http://comrade.ownz.com/", 13, 10
			db		"http://comrade.win32asm.com/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 0 
	szMenuAbout	db		"&About Trillian MSN Static IP Patcher...", 0
	szStatusDone	db		"Patched file successfully!", 0
	szStatusError	db		"Error patching file!", 0
	szFileFilter	db		"msn.dll", 0, "*.dll", 0, "Dynamic Link Libraries (*.dll)", 0, "*.dll", 0, "All Files (*.*)", 0, "*.*", 0, 0
	szError		db		"Error", 0
	szErrorThread	db		"Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 0
	szErrorFinal	db		"Error at %08Xh", 13, 10, "Quitting...", 0
	bOldBytes	db		08Bh, 0ACh, 024h, 088h, 000h, 000h, 000h
;##########################################################################
.data
	bNewBytes	db		0BDh, 000h, 000h, 000h, 000h, 090h, 090h
;##########################################################################
.data?
	hIcon		dd		?
	hIconOpen	dd		?
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)

	data_start	equ		$
	mbp		MSGBOXPARAMS	<>
	ofn		OPENFILENAME	<>
	szFileName	db		MAX_PATH dup (?)
	szIPAddress	db		16 dup (?)
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	pop	edi
	invoke	GetModuleHandle, eax
	mov	[mbp.hInstance], eax
	invoke	DialogBoxParam, eax, 100, 0, ADDR DlgProc, eax
	invoke	ExitProcess, eax
;#########################################################################
DlgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if [uMsg]==WM_INITDIALOG
		mov	eax, [hWnd]
		mov	[mbp.hwndOwner], eax
		invoke	GetSystemMenu, eax, 0
		push	OFFSET szMenuAbout
		push	10
		push	MFT_STRING
		push	eax
		invoke	AppendMenu, eax, MFT_SEPARATOR, 0, 0
		call	AppendMenu
		invoke	LoadIcon, [lParam], 2
		mov	[hIcon], eax
		invoke	SendMessage, [hWnd], WM_SETICON, 1, eax


		invoke	LoadImage, [lParam], 3, IMAGE_ICON, 16, 16, 0
		mov	[hIconOpen], eax
		invoke	SendDlgItemMessage, [hWnd], 103, BM_SETIMAGE, IMAGE_ICON, eax

		invoke	SendDlgItemMessage, [hWnd], 102, EM_SETLIMITTEXT, sizeof szFileName, 0
		invoke	SendDlgItemMessage, [hWnd], 104, EM_SETLIMITTEXT, sizeof szIPAddress, 0
	.elseif [uMsg]==WM_SYSCOMMAND
		cmp	[wParam], 10
		je	@@msga
	.elseif [uMsg]==WM_COMMAND
		mov	eax, [wParam]
		.if ax==103
			mov	[ofn.lStructSize], sizeof ofn
			mov	[ofn.lpstrFilter], OFFSET szFileFilter
			mov	[ofn.lpstrFile], OFFSET szFileName
			mov	[ofn.nMaxFile], sizeof szFileName
			invoke	GetOpenFileName, ADDR ofn
			test	eax, eax
			jz	@@quit
			invoke	SetDlgItemText, [hWnd], 102, ADDR szFileName
		.elseif ax==110
			call	Patch
			test	eax, eax
			mov	eax, OFFSET szStatusError
			mov	ecx, MB_OK OR MB_ICONEXCLAMATION OR MB_APPLMODAL
			jz	@@msgb
			mov	eax, OFFSET szStatusDone
			mov	ecx, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
		@@msgb:	invoke	MessageBox, [hWnd], eax, ADDR szAppTitle, ecx
		.elseif ax==111
		@@msga:	mov	[mbp.cbSize], sizeof mbp
			mov	[mbp.lpszText], OFFSET szMsgAbout
			mov	[mbp.lpszCaption], OFFSET szAppTitle
			mov	[mbp.dwStyle], MB_OK OR MB_APPLMODAL OR MB_USERICON
			mov	[mbp.lpszIcon], 2
			invoke	MessageBoxIndirect, ADDR mbp
		.elseif ax==112
			invoke	PostMessage, [hWnd], WM_CLOSE, 0, 0
		.endif
	.elseif [uMsg]==WM_CLOSE
		invoke	EndDialog, [hWnd], 0
		call	FreeRes
	.endif
@@quit:	xor	eax, eax
	ret
DlgProc endp
;##########################################################################
Patch proc
	LOCAL hFile:DWORD
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@err
	mov	FS:[0], esp
	; critical code
	invoke	GetDlgItemText, [mbp.hwndOwner], 102, ADDR szFileName, sizeof szFileName
	invoke	GetDlgItemText, [mbp.hwndOwner], 104, ADDR szIPAddress, sizeof szIPAddress
	invoke	CreateFile, ADDR szFileName, GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0
	mov	[hFile], eax
	inc	eax
	jz	@@err
	invoke	GetFileSize, [hFile], 0
	cmp	eax, msn_filesize
	jne	@@err
	invoke	SetFilePointer, [hFile], msn_filepos, 0, FILE_BEGIN
	cmp	eax, msn_filepos
	jne	@@err
	invoke	inet_addr, ADDR szIPAddress
	cmp	eax, INADDR_NONE
	jne	@@ip
@@host:	invoke	gethostbyname, ADDR szIPAddress
	test	eax, eax
	jz	@@ip
	mov	eax, [eax][hostent.h_list]
	mov	eax, [eax]
	mov	eax, [eax]
@@ip:	mov	dword ptr [bNewBytes+01h], eax
	mov	edx, OFFSET bOldBytes
	test	eax, eax
	jz	@@old
	mov	edx, OFFSET bNewBytes
@@old:	invoke	WriteFile, [hFile], edx, sizeof bNewBytes, esp, 0
	xor	eax, eax
	inc	eax
	jmp	@@quit
@@err:	xor	eax, eax
@@quit:	pop	FS:[0]
	mov	[esp], eax
	invoke	CloseHandle, [hFile]
	pop	eax
	ret
Patch endp
;##########################################################################
FreeRes proc
	invoke	DestroyIcon, [hIcon]
	ret
FreeRes endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	MessageBox, [mbp.hwndOwner], ADDR szMessage, ADDR szError, MB_OK OR MB_ICONHAND OR MB_APPLMODAL
	invoke	EndDialog, [mbp.hwndOwner], eax
	call	FreeRes
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start